VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3390
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   226
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   312
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton Command5 
      Caption         =   "Recently Used Files Menu"
      Height          =   375
      Left            =   480
      TabIndex        =   4
      Top             =   2520
      Width           =   2055
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Programs Menu"
      Height          =   375
      Left            =   480
      TabIndex        =   3
      Top             =   2040
      Width           =   2055
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Desktop Menu"
      Height          =   375
      Left            =   480
      TabIndex        =   2
      Top             =   1560
      Width           =   2055
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Background Menu for C:\"
      Height          =   375
      Left            =   480
      TabIndex        =   1
      Top             =   1080
      Width           =   2055
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Context Menu for C:\"
      Height          =   375
      Left            =   480
      TabIndex        =   0
      Top             =   600
      Width           =   2055
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

  Implements ISubClass


  Private Const LF_FACESIZE = 32
  Private Const MAX_PATH = 260
  Private Const S_OK = &H0

  Private Const HMARGIN_ICON = 4
  Private Const HMARGIN_TEXT = 4
  Private Const VMARGIN_ICON = 4
  Private Const VMARGIN_TEXT = 4

  ' command ID range reserved for context menu extensions
  Private Const MIN_CONTEXTMENUEXTENSION_CMDID = &H1
  Private Const MAX_CONTEXTMENUEXTENSION_CMDID = &H2000&
  ' minimum command ID available for custom context menu entries
  Private Const MIN_CUSTOMCONTEXTMENUENTRY_CMDID = &H2001&

  Private Const COMMANDID_REFRESH = 1
  Private Const COMMANDID_VERSIONINFO = 2


  Private Enum MenuItemTypeConstants
    mitShellItem
    mitOpenThisFolderItem
    mitEmptyItem
    mitSeparator
  End Enum

  Private Enum MenuTypeConstants
    mtDesktop
    mtRecentDocs
    mtPrograms
  End Enum


  Private Type DLLVERSIONINFO
    cbSize As Long
    dwMajor As Long
    dwMinor As Long
    dwBuildNumber As Long
    dwPlatformId As Long
  End Type

  Private Type DRAWITEMMETRICS
    rcSelection As RECT
    rcGutter As RECT
    rcIcon As RECT
    rcText As RECT
    rcSeparator As RECT
  End Type

  Private Type DRAWITEMSTRUCT
    ctlType As Long
    ctlID As Long
    itemID As Long
    itemAction As Long
    itemState As Long
    hwndItem As Long
    hDC As Long
    rcItem As RECT
    itemData As Long
  End Type

  Private Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(1 To LF_FACESIZE * 2) As Byte
  End Type

  Private Type MARGINS
    cxLeftWidth As Long
    cxRightWidth As Long
    cyTopHeight As Long
    cyBottomHeight As Long
  End Type

  Private Type MEASUREITEMSTRUCT
    ctlType As Long
    ctlID As Long
    itemID As Long
    itemWidth As Long
    itemHeight As Long
    itemData As Long
  End Type

  Private Type MENUITEMDATA
    cbSize As Long
    itemType As MenuItemTypeConstants
    hasSubMenu As Boolean
    IParentISF As IVBShellFolder
    pIDLToParent As Long
    pIDLToDesktop As Long
  End Type

  Private Type MENUITEMINFO
    cbSize As Long
    fMask As Long
    fType As Long
    fState As Long
    wID As Long
    hSubMenu As Long
    hbmpChecked As Long
    hbmpUnchecked As Long
    dwItemData As Long
    dwTypeData As Long
    cch As Long
  End Type

  Private Type NONCLIENTMETRICS
    cbSize As Long
    iBorderWidth As Long
    iScrollWidth As Long
    iScrollHeight As Long
    iCaptionWidth As Long
    iCaptionHeight As Long
    lfCaptionFont As LOGFONT
    iSMCaptionWidth As Long
    iSMCaptionHeight As Long
    lfSMCaptionFont As LOGFONT
    iMenuWidth As Long
    iMenuHeight As Long
    lfMenuFont As LOGFONT
    lfStatusFont As LOGFONT
    lfMessageFont As LOGFONT
    iPaddedBorderWidth As Long
  End Type

  Private Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion(1 To 256) As Byte
  End Type

  Private Type REPARSE_DATA_BUFFER
    ReparseTagLo As Integer
    ReparseTagHi As Integer
    ReparseDataLength As Integer
    Reserved As Integer
    SubstituteNameOffset As Integer
    SubstituteNameLength As Integer
    PrintNameOffset As Integer
    PrintNameLength As Integer
    PathBuffer As Integer
  End Type

  Private Type SHFILEINFO
    hIcon As Long
    iIcon As Long
    dwAttributes As Long
    szDisplayName(1 To 2 * MAX_PATH) As Byte
    szTypeName(1 To 160) As Byte
  End Type


  Private CLSID_AugmentedShellFolder As UUID
  Private CLSID_AugmentedShellFolder2 As UUID
  Private FMTID_Storage As UUID
  Private IID_IAugmentedShellFolder As UUID
  Private IID_IAugmentedShellFolder2 As UUID
  Private IID_IContextMenu As UUID
  Private IID_IContextMenu2 As UUID
  Private IID_IContextMenu3 As UUID
  Private IID_IShellFolder As UUID
  Private IID_IShellFolder2 As UUID
  Private IID_IShellIconOverlay As UUID
  Private IID_IShellLinkA As UUID
  Private IID_IShellLinkW As UUID

  Private bComctl32Version600OrNewer As Boolean
  Private bIsVistaOrNewer As Boolean
  Private enumFlags As SHCONTFConstants
  Private hMenuFont As Long
  Private hImageList As Long
  Private iconSize As Size
  Private IContextMenu As IVBContextMenu
  Private IContextMenu2 As IVBContextMenu2
  Private IContextMenu3 As IVBContextMenu3
  Private IDesktop As IVBShellFolder
  Private IMenuAugmentedISF As IVBAugmentedShellFolder
  Private IMenuAugmentedISF2 As IVBAugmentedShellFolder2
  Private nextCommandID As Long
  Private selectedMenuItemData As Long
  Private sortColumn As Long
  Private themeableOS As Boolean
  Private themedMenus As Boolean


  Private Declare Function CloseHandle Lib "kernel32.dll" (ByVal hObject As Long) As Long
  Private Declare Function CloseThemeData Lib "uxtheme.dll" (ByVal hTheme As Long) As Long
  Private Declare Function CLSIDFromString Lib "ole32.dll" (ByVal lpsz As Long, ByRef pclsid As UUID) As Long
  Private Declare Function CoCreateInstance Lib "ole32.dll" (rclsid As UUID, ByVal pUnkOuter As Any, ByVal dwClsContext As Long, riid As UUID, ppv As Any) As Long
  Private Declare Function CoInitialize Lib "ole32.dll" (ByVal pvReserved As Long) As Long
  Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByVal pDestination As Long, ByVal pSource As Long, ByVal length As Long)
  Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal pv As Long)
  Private Declare Function CreateCompatibleDC Lib "gdi32.dll" (ByVal hDC As Long) As Long
  Private Declare Function CreateFileAsLong Lib "kernel32.dll" Alias "CreateFileW" (ByVal lpFileName As Long, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
  Private Declare Function CreateFontIndirect Lib "gdi32.dll" Alias "CreateFontIndirectW" (ByRef lpLogFont As LOGFONT) As Long
  Private Declare Function CreatePopupMenu Lib "user32.dll" () As Long
  Private Declare Function DeleteDC Lib "gdi32.dll" (ByVal hDC As Long) As Long
  Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
  Private Declare Function DestroyMenu Lib "user32.dll" (ByVal hMenu As Long) As Long
  Private Declare Function DeviceIoControl Lib "kernel32.dll" (ByVal hDevice As Long, ByVal dwIoControlCode As Long, ByVal lpInBuffer As Long, ByVal nInBufferSize As Long, ByVal lpOutBuffer As Long, ByVal nOutBufferSize As Long, ByRef lpBytesReturned As Long, ByVal lpOverlapped As Long) As Long
  Private Declare Function DllGetVersion_comctl32 Lib "comctl32.dll" Alias "DllGetVersion" (pdvi As DLLVERSIONINFO) As Long
  Private Declare Function DrawText Lib "user32.dll" Alias "DrawTextW" (ByVal hDC As Long, ByVal lpStr As Long, ByVal nCount As Long, ByRef lpRect As RECT, ByVal wFormat As Long) As Long
  Private Declare Function DrawThemeBackground Lib "uxtheme.dll" (ByVal hTheme As Long, ByVal hDC As Long, ByVal iPartId As Long, ByVal iStateId As Long, pRect As RECT, ByVal pClipRect As Long) As Long
  Private Declare Function DrawThemeText Lib "uxtheme.dll" (ByVal hTheme As Long, ByVal hDC As Long, ByVal iPartId As Long, ByVal iStateId As Long, ByVal pszText As Long, ByVal iCharCount As Long, ByVal dwTextFlags As Long, ByVal dwTextFlags2 As Long, pRect As RECT) As Long
  Private Declare Function EndMenu Lib "user32.dll" () As Long
  Private Declare Function ExcludeClipRect Lib "gdi32.dll" (ByVal hDC As Long, ByVal nLeftRect As Long, ByVal nTopRect As Long, ByVal nRightRect As Long, ByVal nBottomRect As Long) As Long
  Private Declare Function FillRect Lib "user32.dll" (ByVal hDC As Long, ByRef lpRect As RECT, ByVal hBrush As Long) As Long
  Private Declare Function FreeLibrary Lib "kernel32.dll" (ByVal hModule As Long) As Long
  Private Declare Function GetClientRect Lib "user32.dll" (ByVal hWnd As Long, ByRef lpRect As RECT) As Long
  Private Declare Function GetCursorPos Lib "user32.dll" (ByRef lpPoint As POINT) As Long
  Private Declare Function GetDC Lib "user32.dll" (ByVal hWnd As Long) As Long
  Private Declare Function GetKeyState Lib "user32.dll" (ByVal nVirtKey As Long) As Integer
  Private Declare Function GetMenuDefaultItem Lib "user32.dll" (ByVal hMenu As Long, ByVal fByPos As Long, ByVal gmdiFlags As Long) As Long
  Private Declare Function GetMenuItemCount Lib "user32.dll" (ByVal hMenu As Long) As Long
  Private Declare Function GetMenuItemInfo Lib "user32.dll" Alias "GetMenuItemInfoW" (ByVal hMenu As Long, ByVal uItem As Long, ByVal fByPosition As Long, ByRef lpMenuItemInfo As MENUITEMINFO) As Long
  Private Declare Function GetProcessHeap Lib "kernel32.dll" () As Long
  Private Declare Function GetSysColor Lib "user32.dll" (ByVal nIndex As Long) As Long
  Private Declare Function GetSysColorBrush Lib "user32.dll" (ByVal nIndex As Long) As Long
  Private Declare Function GetSystemMetrics Lib "user32.dll" (ByVal nIndex As Long) As Long
  Private Declare Function GetThemeInt Lib "uxtheme.dll" (ByVal hTheme As Long, ByVal iPartId As Long, ByVal iStateId As Long, ByVal iPropId As Long, piVal As Long) As Long
  Private Declare Function GetThemeMargins Lib "uxtheme.dll" (ByVal hTheme As Long, ByVal hDC As Long, ByVal iPartId As Long, ByVal iStateId As Long, ByVal iPropId As Long, ByVal prc As Long, pMargins As MARGINS) As Long
  Private Declare Function GetThemePartSize Lib "uxtheme.dll" (ByVal hTheme As Long, ByVal hDC As Long, ByVal iPartId As Long, ByVal iStateId As Long, ByVal prc As Long, ByVal eSize As Long, psz As Size) As Long
  Private Declare Function GetThemeTextExtent Lib "uxtheme.dll" (ByVal hTheme As Long, ByVal hDC As Long, ByVal iPartId As Long, ByVal iStateId As Long, ByVal pszText As Long, ByVal iCharCount As Long, ByVal dwTextFlags As Long, ByVal pBoundingRect As Long, pExtentRect As RECT) As Long
  Private Declare Function GetVersionEx Lib "kernel32.dll" Alias "GetVersionExW" (ByRef lpVersionInformation As OSVERSIONINFO) As Long
  Private Declare Function HeapAlloc Lib "kernel32.dll" (ByVal hHeap As Long, ByVal dwFlags As Long, ByVal dwBytes As Long) As Long
  Private Declare Function HeapFree Lib "kernel32.dll" (ByVal hHeap As Long, ByVal dwFlags As Long, ByVal lpMem As Long) As Long
  Private Declare Function ILAppendID Lib "shell32.dll" Alias "#154" (ByVal pIDL As Long, ByVal pmkid As Long, ByVal fAppend As Long) As Long
  Private Declare Function ILClone Lib "shell32.dll" Alias "#18" (ByVal pIDL As Long) As Long
  Private Declare Function ILCreateFromPath Lib "shell32.dll" Alias "ILCreateFromPathW" (ByVal pszPath As Long) As Long
  Private Declare Function ILGetSize Lib "shell32.dll" (ByVal pIDL As Long) As Long
  Private Declare Function ImageList_Draw Lib "comctl32.dll" (ByVal himl As Long, ByVal i As Long, ByVal hdcDst As Long, ByVal x As Long, ByVal y As Long, ByVal fStyle As Long) As Long
  Private Declare Function ImageList_GetIconSize Lib "comctl32.dll" (ByVal himl As Long, ByRef cx As Long, ByRef cy As Long) As Long
  Private Declare Sub InitCommonControls Lib "comctl32.dll" ()
  Private Declare Function InsertMenuItem Lib "user32.dll" Alias "InsertMenuItemW" (ByVal hMenu As Long, ByVal uItem As Long, ByVal fByPosition As Long, ByRef lpcMenuItemInfo As MENUITEMINFO) As Long
  Private Declare Function IsAppThemed Lib "uxtheme.dll" () As Long
  Private Declare Function IsMenu Lib "user32.dll" (ByVal hMenu As Long) As Long
  Private Declare Function IsThemeBackgroundPartiallyTransparent Lib "uxtheme.dll" (ByVal hTheme As Long, ByVal iPartId As Long, ByVal iStateId As Long) As Long
  Private Declare Function IsThemePartDefined Lib "uxtheme.dll" (ByVal hTheme As Long, ByVal iPartId As Long, ByVal iStateId As Long) As Long
  Private Declare Function LoadLibrary Lib "kernel32.dll" Alias "LoadLibraryW" (ByVal lpLibFileName As Long) As Long
  Private Declare Function lstrcpyn Lib "kernel32.dll" Alias "lstrcpynW" (ByVal lpString1 As Long, ByVal lpString2 As Long, ByVal iMaxLength As Long) As Long
  Private Declare Function lstrlen Lib "kernel32.dll" Alias "lstrlenW" (ByVal lpString As Long) As Long
  Private Declare Function lstrlenA Lib "kernel32.dll" (ByVal lpString As String) As Long
  Private Declare Function OffsetRect Lib "user32.dll" (lprc As RECT, ByVal dx As Long, ByVal dy As Long) As Long
  Private Declare Function OpenThemeData Lib "uxtheme.dll" (ByVal hWnd As Long, ByVal pszClassList As Long) As Long
  Private Declare Function PathIsDirectory Lib "shlwapi.dll" Alias "PathIsDirectoryW" (ByVal pszPath As Long) As Long
  Private Declare Function PtInRect Lib "user32.dll" (ByRef lprc As RECT, ByVal x As Long, ByVal y As Long) As Long
  Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hWnd As Long, ByVal hDC As Long) As Long
  Private Declare Function RemoveMenu Lib "user32.dll" (ByVal hMenu As Long, ByVal uPosition As Long, ByVal uFlags As Long) As Long
  Private Declare Function ScreenToClient Lib "user32.dll" (ByVal hWnd As Long, ByRef lpPoint As POINT) As Long
  Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hDC As Long, ByVal hObject As Long) As Long
  Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageW" (ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Private Declare Function SetBkMode Lib "gdi32.dll" (ByVal hDC As Long, ByVal nBkMode As Long) As Long
  Private Declare Function SetRect Lib "user32.dll" (lprc As RECT, ByVal xLeft As Long, ByVal yTop As Long, ByVal xRight As Long, ByVal yBottom As Long) As Long
  Private Declare Function SetTextColor Lib "gdi32.dll" (ByVal hDC As Long, ByVal crColor As Long) As Long
  Private Declare Function SHBindToParent Lib "shell32.dll" (ByVal pIDL As Long, riid As UUID, ppv As IVBShellFolder, ByVal ppidlLast As Long) As Long
  Private Declare Function SHGetDesktopFolder Lib "shell32.dll" (ByRef ppshf As IVBShellFolder) As Long
  Private Declare Function SHGetFileInfo Lib "shell32.dll" Alias "SHGetFileInfoW" (ByVal pszPath As Long, ByVal dwFileAttributes As Long, ByRef psfi As SHFILEINFO, ByVal cbFileInfo As Long, ByVal uFlags As Long) As Long
  Private Declare Function SHGetFolderLocation Lib "shell32.dll" (ByVal hWnd As Long, ByVal csidl As Long, ByVal hToken As Long, ByVal dwFlags As Long, ByRef ppidl As Long) As Long
  Private Declare Function StrRetToBuf Lib "shlwapi.dll" Alias "StrRetToBufW" (ByRef pstr As STRRET, ByRef pIDL As Long, ByVal pszBuf As Long, ByVal cchBuf As Long) As Long
  Private Declare Function SystemParametersInfo Lib "user32.dll" Alias "SystemParametersInfoW" (ByVal uiAction As Long, ByVal uiParam As Long, ByVal pvParam As Long, ByVal fWinIni As Long) As Long
  Private Declare Function TrackPopupMenuEx Lib "user32.dll" (ByVal hMenu As Long, ByVal fuFlags As Long, ByVal x As Long, ByVal y As Long, ByVal hWnd As Long, ByVal lptpm As Long) As Long
  Private Declare Sub ZeroMemory Lib "kernel32.dll" Alias "RtlZeroMemory" (ByVal pDestination As Long, ByVal length As Long)


Private Function ISubClass_GetAppIdentifier() As String
  ISubClass_GetAppIdentifier = "ShellMenuSample"
End Function

Private Function ISubClass_GetProcessingOrder(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As ProcessingOrderConstants
  Const MF_OWNERDRAW = &H100&
  Const MF_POPUP = &H10&
  Const WM_DRAWITEM = &H2B
  Const WM_INITMENUPOPUP = &H117
  Const WM_MEASUREITEM = &H2C
  Const WM_MENUCHAR = &H120
  Const WM_MENURBUTTONUP = &H122
  Const WM_MENUSELECT = &H11F
  Dim ret As ProcessingOrderConstants

  ret = ProcessingOrderConstants.poProcessOriginalOnly
  If hWnd = Me.hWnd Then
    Select Case Msg
      Case WM_DRAWITEM, WM_MEASUREITEM
        If wParam = 0 Then
          ret = ProcessingOrderConstants.poProcessAfterOriginal
        End If
      Case WM_INITMENUPOPUP
        ret = ProcessingOrderConstants.poProcessAfterOriginal
      Case WM_MENUCHAR
        If Not (IContextMenu Is Nothing) Then
          ret = ProcessingOrderConstants.poProcessAfterOriginal
        End If
      Case WM_MENUSELECT
        If IContextMenu Is Nothing Then
          If (HiWord(wParam) And (MF_OWNERDRAW Or MF_POPUP)) = (MF_OWNERDRAW Or MF_POPUP) Then
            ret = ProcessingOrderConstants.poProcessAfterOriginal
          End If
        End If
      Case WM_MENURBUTTONUP
        If IContextMenu Is Nothing Then
          ret = ProcessingOrderConstants.poProcessAfterOriginal
        End If
    End Select
  End If

  ISubClass_GetProcessingOrder = ret
End Function

Private Function ISubClass_WinMain(ByVal iListener As Long, ByVal oldWinMain As Long, ByVal oldRetVal As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Const MF_BYPOSITION = &H400
  Const MFS_DISABLED = &H3
  Const MFT_OWNERDRAW = &H100
  Const MIIM_DATA = &H20
  Const MIIM_FTYPE = &H100
  Const MIIM_STATE = &H1
  Const MIIM_STRING = &H40
  Const WM_DRAWITEM = &H2B
  Const WM_INITMENUPOPUP = &H117
  Const WM_MEASUREITEM = &H2C
  Const WM_MENUCHAR = &H120
  Const WM_MENURBUTTONUP = &H122
  Const WM_MENUSELECT = &H11F
  Dim dispName As STRRET
  Dim drawItemData As DRAWITEMSTRUCT
  Dim hasSubMenu As Boolean
  Dim IParentISF As IVBShellFolder
  Dim IParentISF2 As IVBShellFolder
  Dim itemIconIndex As Long
  Dim itemOverlayIndex As Long
  Dim itemText As String
  Dim itemType As MenuItemTypeConstants
  Dim measureItemData As MEASUREITEMSTRUCT
  Dim menuItem As MENUITEMINFO
  Dim miData As MENUITEMDATA
  Dim numberOfPIDLs As Long
  Dim namespacePIDLs(0 To 0) As Long
  Dim pIDLs() As Long
  Dim pIDLToDesktop As Long
  Dim pIDLToParent As Long
  Dim pMIData As Long
  Dim pt As POINT
  Dim ret As Long

  ret = oldRetVal
  If hWnd = Me.hWnd Then
    Select Case Msg
      Case WM_DRAWITEM
        CopyMemory VarPtr(drawItemData), lParam, LenB(drawItemData)
        If IContextMenu Is Nothing Then
          ' shell menu
          If drawItemData.itemData Then
            itemType = ExtractMenuItemData(drawItemData.itemData, IParentISF, pIDLToParent, pIDLToDesktop, hasSubMenu)
            If (itemType = MenuItemTypeConstants.mitShellItem) Or (itemType = MenuItemTypeConstants.mitOpenThisFolderItem) Then
              itemIconIndex = GetSysIconIndex(pIDLToDesktop)
              If Not (IParentISF Is Nothing) Then
                itemOverlayIndex = GetOverlayIndex(IParentISF, pIDLToParent)

                dispName.uType = STRRET_OFFSET
                If IParentISF.GetDisplayNameOf(pIDLToParent, SHGDNConstants.SHGDN_INFOLDER, dispName) = S_OK Then
                  itemText = STRRETToString(dispName, pIDLToParent)
                End If
                If itemType = MenuItemTypeConstants.mitOpenThisFolderItem Then
                  itemText = "Open " & itemText
                End If
              End If
            ElseIf itemType = MenuItemTypeConstants.mitEmptyItem Then
              itemText = "(Empty)"
              itemIconIndex = -1
              itemOverlayIndex = 0
            End If
            Set IParentISF = Nothing

            DrawItem drawItemData.hDC, itemType, drawItemData.rcItem, itemText, itemIconIndex, itemOverlayIndex, hasSubMenu, drawItemData.itemState, drawItemData.itemAction
            ret = 1
          End If
        Else
          ' shell context menu
          If (drawItemData.itemID >= MIN_CONTEXTMENUEXTENSION_CMDID) And (drawItemData.itemID <= MAX_CONTEXTMENUEXTENSION_CMDID) Then
            If IContextMenu3 Is Nothing Then
              If Not (IContextMenu2 Is Nothing) Then
                IContextMenu2.HandleMenuMsg Msg, wParam, lParam
                ret = 1
              End If
            Else
              IContextMenu3.HandleMenuMsg2 Msg, wParam, lParam, ret
            End If
          End If
        End If

      Case WM_INITMENUPOPUP
        If IContextMenu Is Nothing Then
          ' shell menu
          If selectedMenuItemData Then
            If GetMenuItemCount(wParam) = 1 Then
              ' The menu contains 1 item. Is it our dummy?
              menuItem.cbSize = LenB(menuItem)
              menuItem.fMask = MIIM_DATA
              GetMenuItemInfo wParam, 0, 1, menuItem
              If menuItem.dwItemData = -1 Then
                ' it is
                RemoveMenu wParam, 0, MF_BYPOSITION
              End If
            End If

            If GetMenuItemCount(wParam) = 0 Then
              ' the sub-menu is empty, so fill it
              itemType = ExtractMenuItemData(selectedMenuItemData, IParentISF, pIDLToParent, pIDLToDesktop)
              If itemType = MenuItemTypeConstants.mitShellItem Then
                namespacePIDLs(0) = pIDLToDesktop
                If (Not (IMenuAugmentedISF Is Nothing)) Or (Not (IMenuAugmentedISF2 Is Nothing)) Then
                  ' this is important for the FillShellMenu call below
                  pIDLToDesktop = 0
                End If
                IParentISF.BindToObject pIDLToParent, 0, IID_IShellFolder, IParentISF2
                If Not (IParentISF2 Is Nothing) Then
                  EnumSubItems IParentISF2, namespacePIDLs, 1, pIDLs, numberOfPIDLs
                  If numberOfPIDLs > 0 Then
                    ' fill it with shell items
                    QuickSort IParentISF2, pIDLs, 0, numberOfPIDLs - 1
                    FillShellMenu wParam, IParentISF2, pIDLToDesktop, pIDLs, numberOfPIDLs, True
                    InsertOpenThisFolderMenuItem wParam, selectedMenuItemData
                  Else
                    ' no shell items to display
                    menuItem.cbSize = LenB(menuItem)
                    menuItem.fMask = MIIM_FTYPE Or MIIM_STATE Or MIIM_DATA
                    menuItem.fType = MFT_OWNERDRAW
                    menuItem.fState = MFS_DISABLED
                    miData.cbSize = LenB(miData)
                    miData.itemType = MenuItemTypeConstants.mitEmptyItem
                    pMIData = HeapAlloc(GetProcessHeap, 0, LenB(miData))
                    CopyMemory pMIData, VarPtr(miData), miData.cbSize
                    menuItem.dwItemData = pMIData
                    InsertMenuItem wParam, 0, 1, menuItem

                    InsertOpenThisFolderMenuItem wParam, selectedMenuItemData
                  End If
                  Set IParentISF2 = Nothing
                End If
                Erase pIDLs
              End If
              Set IParentISF = Nothing
            End If
          End If
        Else
          ' shell context menu
          ' TODO: If you've inserted custom context menu entries with sub-menus, you must
          '       filter for those sub-menus here and make sure HandleMenuMsg[2] isn't
          '       called for them.
          '       WM_INITMENUPOPUP sends the sub-menu handle in wParam.
          If IContextMenu3 Is Nothing Then
            If Not (IContextMenu2 Is Nothing) Then
              IContextMenu2.HandleMenuMsg Msg, wParam, lParam
            End If
          Else
            IContextMenu3.HandleMenuMsg2 Msg, wParam, lParam, ret
          End If
        End If

      Case WM_MEASUREITEM
        CopyMemory VarPtr(measureItemData), lParam, LenB(measureItemData)
        If IContextMenu Is Nothing Then
          ' shell menu
          If measureItemData.itemData Then
            itemType = ExtractMenuItemData(measureItemData.itemData, IParentISF, pIDLToParent, pIDLToDesktop)
            If (itemType = MenuItemTypeConstants.mitShellItem) Or (itemType = MenuItemTypeConstants.mitOpenThisFolderItem) Then
              itemIconIndex = GetSysIconIndex(pIDLToDesktop)
              If Not (IParentISF Is Nothing) Then
                itemOverlayIndex = GetOverlayIndex(IParentISF, pIDLToParent)

                dispName.uType = STRRET_OFFSET
                If IParentISF.GetDisplayNameOf(pIDLToParent, SHGDNConstants.SHGDN_INFOLDER, dispName) = S_OK Then
                  itemText = STRRETToString(dispName, pIDLToParent)
                End If
                If itemType = MenuItemTypeConstants.mitOpenThisFolderItem Then
                  itemText = "Open " & itemText
                End If
              End If
            ElseIf itemType = MenuItemTypeConstants.mitEmptyItem Then
              itemText = "(Empty)"
              itemIconIndex = -1
              itemOverlayIndex = 0
            End If
            Set IParentISF = Nothing

            MeasureItem itemText, itemType, measureItemData.itemWidth, measureItemData.itemHeight
            CopyMemory lParam, VarPtr(measureItemData), LenB(measureItemData)
            ret = 1
          End If
        Else
          ' shell context menu
          If (measureItemData.itemID >= MIN_CONTEXTMENUEXTENSION_CMDID) And (measureItemData.itemID <= MAX_CONTEXTMENUEXTENSION_CMDID) Then
            If IContextMenu3 Is Nothing Then
              If Not (IContextMenu2 Is Nothing) Then
                IContextMenu2.HandleMenuMsg Msg, wParam, lParam
                ret = 1
              End If
            Else
              IContextMenu3.HandleMenuMsg2 Msg, wParam, lParam, ret
            End If
          End If
        End If

      Case WM_MENUCHAR
        ' TODO: If you've inserted custom context menu entries with sub-menus, you must
        '       filter for those sub-menus here and make sure HandleMenuMsg[2] isn't
        '       called for them.
        '       WM_MENUCHAR sends the sub-menu handle in lParam.
        If IContextMenu3 Is Nothing Then
          If Not (IContextMenu2 Is Nothing) Then
            IContextMenu2.HandleMenuMsg Msg, wParam, lParam
          End If
        Else
          IContextMenu3.HandleMenuMsg2 Msg, wParam, lParam, ret
        End If

      Case WM_MENUSELECT
        If IContextMenu Is Nothing Then
          menuItem.cbSize = LenB(menuItem)
          menuItem.fMask = MIIM_DATA
          GetMenuItemInfo lParam, LoWord(wParam), 1, menuItem
          selectedMenuItemData = menuItem.dwItemData
        End If

      Case WM_MENURBUTTONUP
        menuItem.cbSize = LenB(menuItem)
        menuItem.fMask = MIIM_DATA
        GetMenuItemInfo lParam, wParam, 1, menuItem
        If menuItem.dwItemData Then
          itemType = ExtractMenuItemData(menuItem.dwItemData, IParentISF, pIDLToParent, pIDLToDesktop)
          If itemType = MenuItemTypeConstants.mitShellItem Then
            GetCursorPos pt
            DisplayShellContextMenu pIDLToDesktop, pt, False, True
          End If
          Set IParentISF = Nothing
        End If
    End Select
  End If

  ISubClass_WinMain = ret
End Function


Private Sub Command1_Click()
  Dim pIDLToDesktop As Long
  Dim pt As POINT

  pIDLToDesktop = ILCreateFromPath(StrPtr("C:\"))
  If pIDLToDesktop Then
    GetCursorPos pt
    DisplayShellContextMenu pIDLToDesktop, pt, False
    CoTaskMemFree pIDLToDesktop
  End If
End Sub

Private Sub Command2_Click()
  Dim pIDLToDesktop As Long
  Dim pt As POINT

  pIDLToDesktop = ILCreateFromPath(StrPtr("C:\"))
  If pIDLToDesktop Then
    GetCursorPos pt
    DisplayShellContextMenu pIDLToDesktop, pt, True
    CoTaskMemFree pIDLToDesktop
  End If
End Sub

Private Sub Command3_Click()
  Dim pt As POINT

  GetCursorPos pt
  DisplayShellMenu pt, MenuTypeConstants.mtDesktop
End Sub

Private Sub Command4_Click()
  Dim pt As POINT

  GetCursorPos pt
  DisplayShellMenu pt, MenuTypeConstants.mtPrograms
End Sub

Private Sub Command5_Click()
  Dim pt As POINT

  GetCursorPos pt
  DisplayShellMenu pt, MenuTypeConstants.mtRecentDocs
End Sub

Private Sub Form_Initialize()
  Const FILE_ATTRIBUTE_NORMAL = &H80
  Const MENU_POPUPITEM = 14
  Const MPI_HOT = 2
  Const SHGFI_SMALLICON = &H1
  Const SHGFI_SYSICONINDEX = &H4000
  Const SHGFI_USEFILEATTRIBUTES = &H10
  Const strCLSID_AugmentedShellFolder = "{91EA3F8B-C99B-11D0-9815-00C04FD91972}"
  Const strCLSID_AugmentedShellFolder2 = "{6413BA2C-B461-11D1-A18A-080036B11A03}"
  Const strFMTID_Storage = "{B725F130-47EF-101A-A5F1-02608C9EEBAC}"
  Const strIID_IAugmentedShellFolder = "{91EA3F8C-C99B-11D0-9815-00C04FD91972}"
  Const strIID_IAugmentedShellFolder2 = "{8DB3B3F4-6CFE-11D1-8AE9-00C04FD918D0}"
  Const strIID_IContextMenu = "{000214E4-0000-0000-C000-000000000046}"
  Const strIID_IContextMenu2 = "{000214F4-0000-0000-C000-000000000046}"
  Const strIID_IContextMenu3 = "{BCFCE0A0-EC17-11D0-8D10-00A0C90F2719}"
  Const strIID_IShellFolder = "{000214E6-0000-0000-C000-000000000046}"
  Const strIID_IShellFolder2 = "{93F2F68C-1D1B-11D3-A30E-00C04F79ABD1}"
  Const strIID_IShellIcon = "{000214E5-0000-0000-C000-000000000046}"
  Const strIID_IShellIconOverlay = "{7D688A70-C613-11D0-999B-00C04FD655E1}"
  Const strIID_IShellLinkA = "{000214EE-0000-0000-C000-000000000046}"
  Const strIID_IShellLinkW = "{000214F9-0000-0000-C000-000000000046}"
  Dim DLLVerData As DLLVERSIONINFO
  Dim fileInfo As SHFILEINFO
  Dim hMod As Long
  Dim hTheme As Long
  Dim osVersion As OSVERSIONINFO

  InitCommonControls
  CoInitialize 0
  osVersion.dwOSVersionInfoSize = LenB(osVersion)
  GetVersionEx osVersion
  bIsVistaOrNewer = (osVersion.dwMajorVersion >= 6)

  hMod = LoadLibrary(StrPtr("uxtheme.dll"))
  If hMod Then
    themeableOS = True
    FreeLibrary hMod
  End If

  With DLLVerData
    .cbSize = LenB(DLLVerData)
    DllGetVersion_comctl32 DLLVerData
    bComctl32Version600OrNewer = (.dwMajor >= 6)
  End With

  If themeableOS Then
    If IsAppThemed Then
      hTheme = OpenThemeData(Me.hWnd, StrPtr("MENU"))
      If hTheme Then
        If IsThemePartDefined(hTheme, MENU_POPUPITEM, MPI_HOT) Then
          themedMenus = True
        End If
        CloseThemeData hTheme
      End If
    End If
  End If

  CLSIDFromString StrPtr(strCLSID_AugmentedShellFolder), CLSID_AugmentedShellFolder
  CLSIDFromString StrPtr(strCLSID_AugmentedShellFolder2), CLSID_AugmentedShellFolder2
  CLSIDFromString StrPtr(strFMTID_Storage), FMTID_Storage
  CLSIDFromString StrPtr(strIID_IAugmentedShellFolder), IID_IAugmentedShellFolder
  CLSIDFromString StrPtr(strIID_IAugmentedShellFolder2), IID_IAugmentedShellFolder2
  CLSIDFromString StrPtr(strIID_IContextMenu), IID_IContextMenu
  CLSIDFromString StrPtr(strIID_IContextMenu2), IID_IContextMenu2
  CLSIDFromString StrPtr(strIID_IContextMenu3), IID_IContextMenu3
  CLSIDFromString StrPtr(strIID_IShellFolder), IID_IShellFolder
  CLSIDFromString StrPtr(strIID_IShellFolder2), IID_IShellFolder2
  CLSIDFromString StrPtr(strIID_IShellIconOverlay), IID_IShellIconOverlay
  CLSIDFromString StrPtr(strIID_IShellLinkA), IID_IShellLinkA
  CLSIDFromString StrPtr(strIID_IShellLinkW), IID_IShellLinkW

  SHGetDesktopFolder IDesktop
  hImageList = SHGetFileInfo(StrPtr("txt"), FILE_ATTRIBUTE_NORMAL, fileInfo, LenB(fileInfo), SHGFI_SYSICONINDEX Or SHGFI_SMALLICON Or SHGFI_USEFILEATTRIBUTES)
  ImageList_GetIconSize hImageList, iconSize.cx, iconSize.cy

  enumFlags = SHCONTFConstants.SHCONTF_FOLDERS Or SHCONTFConstants.SHCONTF_NONFOLDERS
End Sub

Private Sub Form_Load()
  Subclass
End Sub

Private Sub Form_Unload(Cancel As Integer)
  UnSubclass
End Sub


Private Sub ClearMenu(ByVal hMenu As Long)
  Const MF_BYPOSITION = &H400
  Const MIIM_DATA = &H20
  Const MIIM_SUBMENU = &H4
  Dim menuItem As MENUITEMINFO
  Dim miData As MENUITEMDATA

  menuItem.cbSize = LenB(menuItem)
  menuItem.fMask = MIIM_DATA Or MIIM_SUBMENU
  While GetMenuItemCount(hMenu) > 0
    GetMenuItemInfo hMenu, 0, 1, menuItem
    If menuItem.hSubMenu Then
      ClearMenu menuItem.hSubMenu
    End If
    If (menuItem.dwItemData <> 0) And (menuItem.dwItemData <> -1) Then
      CopyMemory VarPtr(miData), menuItem.dwItemData, LenB(miData)
      If (miData.itemType = MenuItemTypeConstants.mitShellItem) Or (miData.itemType = MenuItemTypeConstants.mitOpenThisFolderItem) Then
        Set miData.IParentISF = Nothing
        CoTaskMemFree miData.pIDLToParent
        CoTaskMemFree miData.pIDLToDesktop
      End If
      HeapFree GetProcessHeap, 0, menuItem.dwItemData
    End If
    RemoveMenu hMenu, 0, MF_BYPOSITION
  Wend
End Sub

Private Function CreateShellMenu(namespacePIDLsToDesktop() As Long, ByVal numberOfNamespaces As Long, ByVal withSubMenus As Boolean, Optional ByVal setSortColumnToLastAccessTime As Boolean = False, Optional ByVal noFolderLinks As Boolean = False) As Long
  Const PID_STG_ACCESSTIME = &H10
  Dim columnID As SHCOLUMNID
  Dim hMenu As Long
  Dim i As Long
  Dim INamespaceISF As IVBShellFolder
  Dim IParentISF As IVBShellFolder
  Dim IParentISF2 As IVBShellFolder2
  Dim numberOfPIDLs As Long
  Dim pIDLParentToDesktop As Long
  Dim pIDLs() As Long

  If numberOfNamespaces < 1 Then
    Exit Function
  End If

  If numberOfNamespaces > 1 Then
    For i = 0 To numberOfNamespaces - 1
      If namespacePIDLsToDesktop(i) Then
        IDesktop.BindToObject namespacePIDLsToDesktop(i), 0, IID_IShellFolder, INamespaceISF
        If Not (INamespaceISF Is Nothing) Then
          If IMenuAugmentedISF2 Is Nothing Then
            IMenuAugmentedISF.AddNameSpace 0, INamespaceISF, namespacePIDLsToDesktop(i), enumFlags
          Else
            IMenuAugmentedISF2.AddNameSpace 0, INamespaceISF, namespacePIDLsToDesktop(i), enumFlags
          End If
          Set INamespaceISF = Nothing
        End If
      End If
    Next i
  End If

  If numberOfNamespaces = 1 Then
    pIDLParentToDesktop = namespacePIDLsToDesktop(0)
    Set IParentISF = GetISHFolderInterfaceFQ(pIDLParentToDesktop)
  Else
    If IMenuAugmentedISF2 Is Nothing Then
      IMenuAugmentedISF.QueryInterface IID_IShellFolder, IParentISF
    Else
      IMenuAugmentedISF2.QueryInterface IID_IShellFolder, IParentISF
    End If
  End If
  If setSortColumnToLastAccessTime Then
    IParentISF.QueryInterface IID_IShellFolder2, IParentISF2
    sortColumn = 0
    If Not (IParentISF2 Is Nothing) Then
      i = 0
      Do While IParentISF2.MapColumnToSCID(i, columnID) = S_OK
        If columnID.pid = PID_STG_ACCESSTIME Then
          If (columnID.fmtid.Data1 = FMTID_Storage.Data1) And (columnID.fmtid.Data2 = FMTID_Storage.Data2) And (columnID.fmtid.Data3 = FMTID_Storage.Data3) Then
            If columnID.fmtid.Data4(0) = FMTID_Storage.Data4(0) And _
               columnID.fmtid.Data4(1) = FMTID_Storage.Data4(1) And _
               columnID.fmtid.Data4(2) = FMTID_Storage.Data4(2) And _
               columnID.fmtid.Data4(3) = FMTID_Storage.Data4(3) And _
               columnID.fmtid.Data4(4) = FMTID_Storage.Data4(4) And _
               columnID.fmtid.Data4(5) = FMTID_Storage.Data4(5) And _
               columnID.fmtid.Data4(6) = FMTID_Storage.Data4(6) And _
               columnID.fmtid.Data4(7) = FMTID_Storage.Data4(7) Then
              sortColumn = i
              Exit Do
            End If
          End If
        End If
        i = i + 1
      Loop
      Set IParentISF2 = Nothing
    End If
  End If

  EnumSubItems IParentISF, namespacePIDLsToDesktop, numberOfNamespaces, pIDLs, numberOfPIDLs, noFolderLinks

  If Not (IParentISF Is Nothing) Then
    If numberOfPIDLs > 0 Then
      QuickSort IParentISF, pIDLs, 0, numberOfPIDLs - 1
      hMenu = CreatePopupMenu
      If hMenu Then
        FillShellMenu hMenu, IParentISF, pIDLParentToDesktop, pIDLs, numberOfPIDLs, withSubMenus
      End If
    End If
    Set IParentISF = Nothing
  End If
  Erase pIDLs

  CreateShellMenu = hMenu
End Function

Private Sub DisplayShellContextMenu(ByVal pIDLToDesktop As Long, position As POINT, ByVal backgroundMenu As Boolean, Optional ByVal recurseMode As Boolean = False)
  Const MFS_ENABLED = &H0
  Const MFT_SEPARATOR = &H800
  Const MFT_STRING = &H0
  Const MIIM_FTYPE = &H100
  Const MIIM_ID = &H2
  Const MIIM_STATE = &H1
  Const MIIM_STRING = &H40
  Const SM_MENUDROPALIGNMENT = 40
  Const SW_SHOWDEFAULT = 10
  Const TPM_LEFTALIGN = &H0
  Const TPM_LEFTBUTTON = &H0
  Const TPM_RECURSE = &H1
  Const TPM_RETURNCMD = &H100
  Const TPM_RIGHTALIGN = &H8
  Const TPM_TOPALIGN = &H0
  Const VK_SHIFT = &H10
  Dim clickedVerb As String
  Dim commandID As Long
  Dim flags As Long
  Dim hMenu As Long
  Dim invokeData As CMINVOKECOMMANDINFOEX
  Dim IParentISF As IVBShellFolder
  Dim itemAttributes As SFGAOConstants
  Dim menuFlags As CMFConstants
  Dim menuItem As MENUITEMINFO
  Dim menuItemPosition As Long
  Dim pIDLToParent As Long

  If backgroundMenu Then
    Set IParentISF = GetISHFolderInterfaceFQ(pIDLToDesktop)
  Else
    SplitFullyQualifiedPIDL pIDLToDesktop, IParentISF, pIDLToParent
  End If
  If Not (IParentISF Is Nothing) Then
    If backgroundMenu Then
      IParentISF.CreateViewObject Me.hWnd, IID_IContextMenu, IContextMenu
    Else
      IParentISF.GetUIObjectOf Me.hWnd, 1, pIDLToParent, IID_IContextMenu, 0, IContextMenu
    End If
    If Not (IContextMenu Is Nothing) Then
      IContextMenu.QueryInterface IID_IContextMenu2, IContextMenu2
      If Not (IContextMenu2 Is Nothing) Then
        IContextMenu2.QueryInterface IID_IContextMenu3, IContextMenu3
      End If

      hMenu = CreatePopupMenu
      If hMenu Then
        ' fill menu
        menuFlags = CMFConstants.CMF_NORMAL
        If Not backgroundMenu Then
          itemAttributes = SFGAOConstants.SFGAO_CANRENAME
          IParentISF.GetAttributesOf 1, pIDLToParent, itemAttributes
          If itemAttributes And SFGAOConstants.SFGAO_CANRENAME Then
            menuFlags = menuFlags Or CMFConstants.CMF_CANRENAME
          End If
        End If
        If GetKeyState(VK_SHIFT) And &H8000& Then
          menuFlags = menuFlags Or CMFConstants.CMF_EXTENDEDVERBS
        End If
        IContextMenu.QueryContextMenu hMenu, 0, MIN_CONTEXTMENUEXTENSION_CMDID, MAX_CONTEXTMENUEXTENSION_CMDID, menuFlags

        ' TODO: Insert custom commands here. Be sure to not use IDs below MIN_CUSTOMCONTEXTMENUENTRY_CMDID
        If backgroundMenu Then
          menuItemPosition = 0
          menuItem.cbSize = LenB(menuItem)

          menuItem.fMask = MIIM_ID Or MIIM_FTYPE Or MIIM_STATE Or MIIM_STRING
          menuItem.fType = MFT_STRING
          menuItem.fState = MFS_ENABLED
          menuItem.wID = MIN_CUSTOMCONTEXTMENUENTRY_CMDID + COMMANDID_REFRESH
          menuItem.dwTypeData = StrPtr("Aktualisieren")
          InsertMenuItem hMenu, menuItemPosition, 1, menuItem
          menuItemPosition = menuItemPosition + 1

          menuItem.fMask = MIIM_FTYPE
          menuItem.fType = MFT_SEPARATOR
          InsertMenuItem hMenu, menuItemPosition, 1, menuItem
        Else
          menuItemPosition = GetMenuItemCount(hMenu)
          menuItem.cbSize = LenB(menuItem)

          menuItem.fMask = MIIM_FTYPE
          menuItem.fType = MFT_SEPARATOR
          InsertMenuItem hMenu, menuItemPosition, 1, menuItem
          menuItemPosition = menuItemPosition + 1

          menuItem.fMask = MIIM_ID Or MIIM_FTYPE Or MIIM_STATE Or MIIM_STRING
          menuItem.fType = MFT_STRING
          menuItem.fState = MFS_ENABLED
          menuItem.wID = MIN_CUSTOMCONTEXTMENUENTRY_CMDID + COMMANDID_VERSIONINFO
          menuItem.dwTypeData = StrPtr("Versionsinfos")
          InsertMenuItem hMenu, menuItemPosition, 1, menuItem
        End If

        RemoveDoubleSeparators hMenu

        flags = TPM_TOPALIGN Or TPM_LEFTBUTTON Or TPM_RETURNCMD
        If GetSystemMetrics(SM_MENUDROPALIGNMENT) Then
          flags = flags Or TPM_RIGHTALIGN
        Else
          flags = flags Or TPM_LEFTALIGN
        End If
        If recurseMode Then
          ' allow menu context menus
          flags = flags Or TPM_RECURSE
        End If

        commandID = TrackPopupMenuEx(hMenu, flags, position.x, position.y, Me.hWnd, 0)
        If commandID > 0 Then
          If recurseMode Then
            ' we want to close the main menu, too
            EndMenu
          End If

          If (commandID >= MIN_CONTEXTMENUEXTENSION_CMDID) And (commandID <= MAX_CONTEXTMENUEXTENSION_CMDID) Then
            commandID = commandID - MIN_CONTEXTMENUEXTENSION_CMDID

            clickedVerb = String(MAX_PATH, Chr$(0))
            IContextMenu.GetCommandString commandID, GCSConstants.GCS_VERB Or GCSConstants.GCS_UNICODE, 0, StrPtr(clickedVerb), MAX_PATH
            clickedVerb = Left$(clickedVerb, lstrlen(StrPtr(clickedVerb)))
            MsgBox "You clicked verb " & clickedVerb

            With invokeData
              .StructSize = LenB(invokeData)
              .Mask = CMIC_MASKConstants.CMIC_MASK_ASYNCOK Or CMIC_MASKConstants.CMIC_MASK_FLAG_LOG_USAGE
              If menuFlags And CMFConstants.CMF_EXTENDEDVERBS Then
                .Mask = .Mask Or CMIC_MASKConstants.CMIC_MASK_SHIFT_DOWN
              End If
              .hWnd = Me.hWnd
              .Verb = MakeDWord(commandID, 0)
              .Showflags = SW_SHOWDEFAULT
            End With
            IContextMenu.InvokeCommand invokeData
          Else
            commandID = commandID - MIN_CUSTOMCONTEXTMENUENTRY_CMDID
            MsgBox "TODO: Execute custom command (ID 0x" & Hex(commandID) & ")"
          End If
        End If

        DestroyMenu hMenu
      End If

      Set IContextMenu = Nothing
      Set IContextMenu2 = Nothing
      Set IContextMenu3 = Nothing
    End If

    Set IParentISF = Nothing
  End If
End Sub

Private Sub DisplayShellMenu(position As POINT, ByVal menuType As MenuTypeConstants)
  Const CLSCTX_INPROC_SERVER = &H1
  Const CLSCTX_INPROC_HANDLER = &H2
  Const CSIDL_COMMON_PROGRAMS = &H17
  Const CSIDL_DESKTOP = &H0
  Const CSIDL_PROGRAMS = &H2
  Const CSIDL_RECENT = &H8
  Const GMDI_GOINTOPOPUPS = &H2
  Const MIIM_DATA = &H20
  Const SM_MENUDROPALIGNMENT = 40
  Const SPI_GETNONCLIENTMETRICS = 41
  Const SW_SHOWDEFAULT = 10
  Const TPM_LEFTALIGN = &H0
  Const TPM_LEFTBUTTON = &H0
  Const TPM_RETURNCMD = &H100
  Const TPM_RIGHTALIGN = &H8
  Const TPM_TOPALIGN = &H0
  Dim clickedPath As String
  Dim commandID As Long
  Dim dispName As STRRET
  Dim flags As Long
  Dim hMenu As Long
  Dim hMenu2 As Long
  Dim i As Long
  Dim invokeData As CMINVOKECOMMANDINFOEX
  Dim IParentISF As IVBShellFolder
'  Dim itemAttributes As SFGAOConstants
  Dim menuItem As MENUITEMINFO
  Dim ncMetrics As NONCLIENTMETRICS
  Dim numberOfPIDLs As Long
  Dim pIDLs() As Long
  Dim pIDLToDesktop As Long
  Dim pIDLToParent As Long

  nextCommandID = 1

  ncMetrics.cbSize = LenB(ncMetrics) - IIf(bIsVistaOrNewer, 0, LenB(ncMetrics.iPaddedBorderWidth))
  If SystemParametersInfo(SPI_GETNONCLIENTMETRICS, ncMetrics.cbSize, VarPtr(ncMetrics), 0) Then
    hMenuFont = CreateFontIndirect(ncMetrics.lfMenuFont)
  End If

  If menuType = MenuTypeConstants.mtPrograms Then
    CoCreateInstance CLSID_AugmentedShellFolder2, Nothing, CLSCTX_INPROC_SERVER Or CLSCTX_INPROC_HANDLER, IID_IAugmentedShellFolder2, IMenuAugmentedISF2
    If IMenuAugmentedISF2 Is Nothing Then
      CoCreateInstance CLSID_AugmentedShellFolder, Nothing, CLSCTX_INPROC_SERVER Or CLSCTX_INPROC_HANDLER, IID_IAugmentedShellFolder, IMenuAugmentedISF
      If IMenuAugmentedISF Is Nothing Then
        MsgBox "Cannot augment folders!"
        GoTo CleanUp
      End If
    End If

    ReDim pIDLs(0 To 1) As Long
    SHGetFolderLocation Me.hWnd, CSIDL_PROGRAMS, 0, 0, pIDLs(0)
    SHGetFolderLocation Me.hWnd, CSIDL_COMMON_PROGRAMS, 0, 0, pIDLs(1)
    numberOfPIDLs = 2
  Else
    ReDim pIDLs(0 To 0) As Long
    Select Case menuType
      Case MenuTypeConstants.mtDesktop
        SHGetFolderLocation Me.hWnd, CSIDL_DESKTOP, 0, 0, pIDLs(0)
      Case MenuTypeConstants.mtRecentDocs
        SHGetFolderLocation Me.hWnd, CSIDL_RECENT, 0, 0, pIDLs(0)
    End Select
    numberOfPIDLs = 1
  End If

  hMenu = CreateShellMenu(pIDLs, numberOfPIDLs, True, menuType = MenuTypeConstants.mtRecentDocs, menuType = MenuTypeConstants.mtRecentDocs)
  If hMenu Then
    flags = TPM_TOPALIGN Or TPM_LEFTBUTTON Or TPM_RETURNCMD
    If GetSystemMetrics(SM_MENUDROPALIGNMENT) Then
      flags = flags Or TPM_RIGHTALIGN
    Else
      flags = flags Or TPM_LEFTALIGN
    End If

    commandID = TrackPopupMenuEx(hMenu, flags, position.x, position.y, Me.hWnd, 0)
    If commandID > 0 Then
      menuItem.cbSize = LenB(menuItem)
      menuItem.fMask = MIIM_DATA
      GetMenuItemInfo hMenu, commandID, 0, menuItem
      ExtractMenuItemData menuItem.dwItemData, IParentISF, pIDLToParent, pIDLToDesktop
      If Not (IParentISF Is Nothing) Then
        If IParentISF.GetDisplayNameOf(pIDLToParent, SHGDNConstants.SHGDN_FORPARSING, dispName) = S_OK Then
          clickedPath = STRRETToString(dispName, pIDLToParent)
        End If

'        itemAttributes = SFGAOConstants.SFGAO_FILESYSTEM
'        IParentISF.GetAttributesOf 1, pIDLToParent, itemAttributes
'
'        If (itemAttributes And SFGAOConstants.SFGAO_FILESYSTEM) = 0 Then
          ' item is not part of the filesystem
          IParentISF.GetUIObjectOf Me.hWnd, 1, pIDLToParent, IID_IContextMenu, 0, IContextMenu
          If Not (IContextMenu Is Nothing) Then
            hMenu2 = CreatePopupMenu
            If hMenu2 Then
              IContextMenu.QueryContextMenu hMenu2, 0, &H1, &HFFFF&, CMFConstants.CMF_DEFAULTONLY
              commandID = GetMenuDefaultItem(hMenu2, 0, GMDI_GOINTOPOPUPS)
              If commandID > 0 Then
                commandID = commandID - 1
                With invokeData
                  .StructSize = LenB(invokeData)
                  .Mask = CMIC_MASKConstants.CMIC_MASK_ASYNCOK Or CMIC_MASKConstants.CMIC_MASK_FLAG_LOG_USAGE
                  .hWnd = Me.hWnd
                  .Verb = MakeDWord(commandID, 0)
                  .Showflags = SW_SHOWDEFAULT
                End With
                IContextMenu.InvokeCommand invokeData
              End If
              DestroyMenu hMenu2
            End If
            Set IContextMenu = Nothing
          End If
'        End If

        Set IParentISF = Nothing
      End If
      MsgBox "You clicked: " & clickedPath
    End If

    ClearMenu hMenu
    DestroyMenu hMenu
  End If

CleanUp:
  For i = 0 To numberOfPIDLs - 1
    CoTaskMemFree pIDLs(i)
  Next i
  Erase pIDLs
  Set IMenuAugmentedISF = Nothing
  Set IMenuAugmentedISF2 = Nothing
  selectedMenuItemData = 0

  If hMenuFont Then
    DeleteObject hMenuFont
    hMenuFont = 0
  End If
End Sub

Private Sub DrawItem(ByVal hDC As Long, itemType As MenuItemTypeConstants, itemRectangle As RECT, itemText As String, itemIconIndex As Long, itemOverlayIndex As Long, drawSubMenuArrow As Boolean, itemState As Long, itemAction As Long)
  Const COLOR_HIGHLIGHT = 13
  Const COLOR_HIGHLIGHTTEXT = 14
  Const COLOR_MENU = 4
  Const COLOR_MENUTEXT = 7
  Const DT_LEFT = &H0
  Const DT_NOPREFIX = &H800
  Const DT_SINGLELINE = &H20
  Const DT_VCENTER = &H4
  Const ILD_TRANSPARENT = &H1
  Const MENU_POPUPBACKGROUND = 9
  Const MENU_POPUPGUTTER = 13
  Const MENU_POPUPITEM = 14
  Const MENU_POPUPSEPARATOR = 15
  Const MENU_POPUPSUBMENU = 16
  Const MPI_DISABLED = 3
  Const MPI_DISABLEDHOT = 4
  Const MPI_HOT = 2
  Const MPI_NORMAL = 1
  Const MSM_DISABLED = 2
  Const MSM_NORMAL = 1
  Const ODS_DISABLED = &H4
  Const ODS_HOTLIGHT = &H40
  Const ODS_INACTIVE = &H80
  Const ODS_SELECTED = &H1
  Const TMT_CONTENTMARGINS = 3602
  Const TRANSPARENT = 1
  Const TS_TRUE = 1
  Const WM_GETFONT = &H31
  Dim arrowRectangle As RECT
  Dim arrowStateID As Long
  Dim cx As Long
  Dim cy As Long
  Dim hOldFont As Long
  Dim hTheme As Long
  Dim itemMetrics As DRAWITEMMETRICS
  Dim itemStateID As Long
  Dim measureRectangle As RECT
  Dim oldColor As Long
  Dim overlayMask As Long
  Dim popupSubmenuArrowMargins As MARGINS
  Dim popupSubmenuArrowSize As Size
  Dim textRectangle As RECT
  Dim x As Long
  Dim y As Long

  If themeableOS Then
    hTheme = OpenThemeData(Me.hWnd, StrPtr("MENU"))
    If hTheme Then
      If itemState And (ODS_INACTIVE Or ODS_DISABLED) Then
        If itemState And (ODS_HOTLIGHT Or ODS_SELECTED) Then
          itemStateID = MPI_DISABLEDHOT
        Else
          itemStateID = MPI_DISABLED
        End If
        arrowStateID = MSM_DISABLED
      ElseIf itemState And (ODS_HOTLIGHT Or ODS_SELECTED) Then
        itemStateID = MPI_HOT
        arrowStateID = MSM_NORMAL
      Else
        itemStateID = MPI_NORMAL
        arrowStateID = MSM_NORMAL
      End If

      LayoutMenuItem hTheme, itemType, itemRectangle, itemText, itemMetrics

      If IsThemeBackgroundPartiallyTransparent(hTheme, MENU_POPUPITEM, itemStateID) Then
        DrawThemeBackground hTheme, hDC, MENU_POPUPBACKGROUND, 0, itemRectangle, 0
      End If
      DrawThemeBackground hTheme, hDC, MENU_POPUPGUTTER, 0, itemMetrics.rcGutter, 0

      If itemType = MenuItemTypeConstants.mitSeparator Then
        DrawThemeBackground hTheme, hDC, MENU_POPUPSEPARATOR, 0, itemMetrics.rcSeparator, 0
      Else
        DrawThemeBackground hTheme, hDC, MENU_POPUPITEM, itemStateID, itemMetrics.rcSelection, 0

        If itemIconIndex >= 0 Then
          If itemOverlayIndex > 0 Then
            overlayMask = itemOverlayIndex * (2 ^ 8)
          End If
          ImageList_Draw hImageList, itemIconIndex, hDC, itemMetrics.rcIcon.Left, itemMetrics.rcIcon.Top, ILD_TRANSPARENT Or overlayMask
        End If
        DrawThemeText hTheme, hDC, MENU_POPUPITEM, itemStateID, StrPtr(itemText), Len(itemText), DT_NOPREFIX Or DT_LEFT Or DT_SINGLELINE, 0, itemMetrics.rcText
      End If

      If drawSubMenuArrow Then
        GetThemePartSize hTheme, 0, MENU_POPUPSUBMENU, 0, 0, TS_TRUE, popupSubmenuArrowSize
        GetThemeMargins hTheme, 0, MENU_POPUPSUBMENU, 0, TMT_CONTENTMARGINS, 0, popupSubmenuArrowMargins

        popupSubmenuArrowSize.cx = popupSubmenuArrowSize.cx + popupSubmenuArrowMargins.cxLeftWidth + popupSubmenuArrowMargins.cxRightWidth
        popupSubmenuArrowSize.cy = popupSubmenuArrowSize.cy + popupSubmenuArrowMargins.cyTopHeight + popupSubmenuArrowMargins.cyBottomHeight

        ' TODO: this calculation is wrong
        cx = popupSubmenuArrowSize.cx
        cy = popupSubmenuArrowSize.cy
        x = itemRectangle.Right - cx
        y = itemRectangle.Top
        SetRect measureRectangle, x, y, x + cx, y + cy
        SetRect arrowRectangle, measureRectangle.Left + popupSubmenuArrowMargins.cxLeftWidth, measureRectangle.Top + popupSubmenuArrowMargins.cyTopHeight, measureRectangle.Right - popupSubmenuArrowMargins.cxRightWidth, measureRectangle.Bottom - popupSubmenuArrowMargins.cyBottomHeight
        OffsetRect arrowRectangle, 0, ((itemRectangle.Bottom - itemRectangle.Top) - cy) / 2
        ' correction for the failure mentioned above
        OffsetRect arrowRectangle, 2, -2

        DrawThemeBackground hTheme, hDC, MENU_POPUPSUBMENU, arrowStateID, arrowRectangle, 0

        ' this will prevent drawing of the default arrow
        ExcludeClipRect hDC, itemRectangle.Left, itemRectangle.Top, itemRectangle.Right, itemRectangle.Bottom
      End If

      CloseThemeData hTheme
      Exit Sub
    End If
  End If

  If hMenuFont Then
    hOldFont = SelectObject(hDC, hMenuFont)
  Else
    hOldFont = SelectObject(hDC, SendMessage(Me.hWnd, WM_GETFONT, 0, 0))
  End If

  If itemState And ODS_SELECTED Then
    FillRect hDC, itemRectangle, GetSysColorBrush(COLOR_HIGHLIGHT)
  Else
    FillRect hDC, itemRectangle, GetSysColorBrush(COLOR_MENU)
  End If
  x = itemRectangle.Left + HMARGIN_ICON
  If itemIconIndex >= 0 Then
    y = itemRectangle.Top + (itemRectangle.Bottom - itemRectangle.Top - iconSize.cy) / 2
    If itemOverlayIndex > 0 Then
      overlayMask = itemOverlayIndex * (2 ^ 8)
    End If
    ImageList_Draw hImageList, itemIconIndex, hDC, x, y, ILD_TRANSPARENT Or overlayMask
  End If
  x = x + iconSize.cx + HMARGIN_ICON + HMARGIN_TEXT
  If itemText <> "" Then
    SetBkMode hDC, TRANSPARENT
    If itemState And ODS_SELECTED Then
      oldColor = SetTextColor(hDC, GetSysColor(COLOR_HIGHLIGHTTEXT))
    Else
      oldColor = SetTextColor(hDC, GetSysColor(COLOR_MENUTEXT))
    End If

    textRectangle.Left = x
    textRectangle.Top = itemRectangle.Top
    textRectangle.Right = itemRectangle.Right - HMARGIN_TEXT
    textRectangle.Bottom = itemRectangle.Bottom
    DrawText hDC, StrPtr(itemText), Len(itemText), textRectangle, DT_NOPREFIX Or DT_LEFT Or DT_SINGLELINE Or DT_VCENTER

    SetTextColor hDC, oldColor
  End If

  If hOldFont Then
    SelectObject hDC, hOldFont
  End If
End Sub

Private Sub EnumSubItems(IParentISF As IVBShellFolder, namespacePIDLsToDesktop() As Long, ByVal numberOfNamespaces As Long, ByRef pIDLs() As Long, numberOfPIDLs As Long, Optional ByVal noFolderLinks As Boolean = False)
  Dim i As Long
  Dim IEnum As IVBEnumIDList
  Dim itemAttributes As SFGAOConstants
  Dim linkTarget As String
  Dim pIDLOfLinkTarget As Long
  Dim pIDLSubItem_ToParent As Long
  Dim skip As Boolean

  numberOfPIDLs = 0
  Erase pIDLs

  If Not (IParentISF Is Nothing) Then
    'IParentISF.EnumObjects Me.hWnd, enumFlags, IEnum
    IParentISF.EnumObjects 0, enumFlags, IEnum
    If Not (IEnum Is Nothing) Then
      ReDim pIDLs(0 To 0) As Long
      While IEnum.Next(1, pIDLSubItem_ToParent, 0) = S_OK
        If numberOfPIDLs = UBound(pIDLs) Then
          ReDim Preserve pIDLs(0 To numberOfPIDLs + 9) As Long
        End If

        skip = False
        If noFolderLinks Then
'          itemAttributes = SFGAOConstants.SFGAO_LINK
'          IParentISF.GetAttributesOf 1, pIDLSubItem_ToParent, itemAttributes
'          If itemAttributes And SFGAOConstants.SFGAO_LINK Then
            linkTarget = GetLinkTarget(IParentISF, pIDLSubItem_ToParent)
            pIDLOfLinkTarget = ILCreateFromPath(StrPtr(linkTarget))
            If pIDLOfLinkTarget Then
              ' don't display this item if the target is a directory
              skip = PathIsDirectory(StrPtr(linkTarget))
              CoTaskMemFree pIDLOfLinkTarget
            Else
              ' target does not exist - don't display this item
              skip = True
            End If
'          End If
        End If

        If Not skip Then
          pIDLs(numberOfPIDLs) = pIDLSubItem_ToParent
          numberOfPIDLs = numberOfPIDLs + 1
        End If
      Wend
      Set IEnum = Nothing
    End If
  End If
End Sub

Private Function ExtractMenuItemData(ByVal pMenuItemData As Long, IParentISF As IVBShellFolder, pIDLToParent As Long, pIDLToDesktop As Long, Optional hasSubMenu As Boolean = False) As MenuItemTypeConstants
  Dim miData As MENUITEMDATA

  If pMenuItemData Then
    CopyMemory VarPtr(miData), pMenuItemData, LenB(miData)
    If (miData.itemType = MenuItemTypeConstants.mitShellItem) Or (miData.itemType = MenuItemTypeConstants.mitOpenThisFolderItem) Then
      Set IParentISF = miData.IParentISF
      pIDLToParent = miData.pIDLToParent
      pIDLToDesktop = miData.pIDLToDesktop
      ZeroMemory VarPtr(miData.IParentISF), 4
    End If
    hasSubMenu = miData.hasSubMenu
    ExtractMenuItemData = miData.itemType
  End If
End Function

Private Sub FillShellMenu(ByVal hMenu As Long, IParentISF As IVBShellFolder, ByVal pIDLParentToDesktop As Long, ByRef pIDLs() As Long, numberOfPIDLs As Long, ByVal withSubMenus As Boolean)
  Const MFS_ENABLED = &H0
  Const MFT_OWNERDRAW = &H100
  Const MFT_STRING = &H0
  Const MIIM_DATA = &H20
  Const MIIM_FTYPE = &H100
  Const MIIM_ID = &H2
  Const MIIM_STATE = &H1
  Const MIIM_STRING = &H40
  Const MIIM_SUBMENU = &H4
  Dim dispName As STRRET
  Dim hSubMenu As Long
  Dim i As Long
  Dim itemAttributes As SFGAOConstants
  Dim menuItem As MENUITEMINFO
  Dim menuItem2 As MENUITEMINFO
  Dim miData As MENUITEMDATA
  Dim path As String
  Dim pMIData As Long

  If numberOfPIDLs > 0 Then
    menuItem.cbSize = LenB(menuItem)
    menuItem.fMask = MIIM_ID Or MIIM_FTYPE Or MIIM_STATE Or MIIM_STRING Or MIIM_DATA Or MIIM_SUBMENU
    menuItem.fType = MFT_OWNERDRAW
    menuItem.fState = MFS_ENABLED
    miData.cbSize = LenB(miData)
    For i = 0 To numberOfPIDLs - 1
      menuItem.wID = nextCommandID
      On Error Resume Next
      nextCommandID = nextCommandID + 1
      If Err Then
        MsgBox "Too many menu items!"
      End If
      On Error GoTo 0

      miData.itemType = MenuItemTypeConstants.mitShellItem
      Set miData.IParentISF = IParentISF
      miData.pIDLToParent = pIDLs(i)
      If pIDLParentToDesktop Then
        miData.pIDLToDesktop = ILAppendID(ILClone(pIDLParentToDesktop), miData.pIDLToParent, 1)
      Else
        dispName.uType = STRRET_OFFSET
        If miData.IParentISF.GetDisplayNameOf(miData.pIDLToParent, SHGDNConstants.SHGDN_FORPARSING, dispName) = S_OK Then
          path = STRRETToString(dispName, miData.pIDLToParent)
          miData.pIDLToDesktop = ILCreateFromPath(StrPtr(path))
        End If
      End If

      miData.hasSubMenu = False
      If withSubMenus Then
        menuItem.hSubMenu = 0
        ' check for SFGAO_STREAM to filter out compressed folders (zip files)
        itemAttributes = SFGAOConstants.SFGAO_FOLDER Or SFGAOConstants.SFGAO_STREAM
        miData.IParentISF.GetAttributesOf 1, miData.pIDLToParent, itemAttributes
        If itemAttributes And SFGAOConstants.SFGAO_FOLDER Then
          If (itemAttributes And SFGAOConstants.SFGAO_STREAM) = 0 Then
            ' create a sub-menu and insert a dummy item
            hSubMenu = CreatePopupMenu
            menuItem2.cbSize = LenB(menuItem2)
            menuItem2.fMask = MIIM_FTYPE Or MIIM_DATA Or MIIM_STRING
            menuItem2.dwItemData = -1
            menuItem2.fType = MFT_STRING
            menuItem2.dwTypeData = StrPtr("Dummy")
            InsertMenuItem hSubMenu, 0, 1, menuItem2
            menuItem.hSubMenu = hSubMenu
            miData.hasSubMenu = True
          End If
        End If
      End If

      pMIData = HeapAlloc(GetProcessHeap, 0, LenB(miData))
      CopyMemory pMIData, VarPtr(miData), miData.cbSize
      menuItem.dwItemData = pMIData
      ZeroMemory VarPtr(miData.IParentISF), 4

      InsertMenuItem hMenu, i, 1, menuItem
    Next i
  End If
End Sub

Private Function GetISHFolderInterfaceFQ(pIDLToDesktop As Long) As IVBShellFolder
  Dim dummy As IVBShellFolder
  Dim pIDLToParent As Long
  Dim ret As IVBShellFolder

  If ILGetSize(pIDLToDesktop) = 2 Then
    Set GetISHFolderInterfaceFQ = IDesktop
  Else
    SplitFullyQualifiedPIDL pIDLToDesktop, dummy, pIDLToParent
    If Not (dummy Is Nothing) Then
      dummy.BindToObject pIDLToParent, 0, IID_IShellFolder, ret
    End If
    Set GetISHFolderInterfaceFQ = ret
    Set dummy = Nothing
    Set ret = Nothing
  End If
End Function

Private Function GetLinkTarget(IParentISF As IVBShellFolder, pIDLToParent As Long) As String
  Const FILE_FLAG_BACKUP_SEMANTICS = &H2000000
  Const FILE_FLAG_OPEN_REPARSE_POINT = &H200000
  Const FILE_SHARE_READ = &H1
  Const FSCTL_GET_REPARSE_POINT = &H900A8
  Const INVALID_HANDLE_VALUE = -1
  Const MAXIMUM_REPARSE_DATA_BUFFER_SIZE = 16 * 1024
  Const OPEN_EXISTING = 3
  Dim bBuffer(0 To MAXIMUM_REPARSE_DATA_BUFFER_SIZE - 1) As Byte
  Dim bytesReturned As Long
  Dim dispName As STRRET
  Dim DummyA As WIN32_FIND_DATAA
  Dim DummyW As WIN32_FIND_DATAW
  Dim hReparsePoint As Long
  Dim IShLinkA As IVBShellLinkA
  Dim IShLinkW As IVBShellLinkW
  Dim path As String
  Dim posNull As Long
  Dim reparseDetails As REPARSE_DATA_BUFFER
  Dim ret As String

  IParentISF.GetUIObjectOf 0, 1, pIDLToParent, IID_IShellLinkW, 0, IShLinkW
  If Not (IShLinkW Is Nothing) Then
    ' NOTE: We lose Unicode support here
    ret = String$(MAX_PATH, Chr$(0))
    IShLinkW.GetPath ret, Len(ret), DummyW, SLGPConstants.SLGP_UNCPRIORITY
    GetLinkTarget = Left$(ret, lstrlenA(ret))

    Set IShLinkW = Nothing
  Else
    IParentISF.GetUIObjectOf 0, 1, pIDLToParent, IID_IShellLinkA, 0, IShLinkA
    If Not (IShLinkA Is Nothing) Then
      ret = String$(MAX_PATH, Chr$(0))
      IShLinkA.GetPath ret, Len(ret), DummyA, SLGPConstants.SLGP_UNCPRIORITY
      GetLinkTarget = Left$(ret, lstrlenA(ret))

      Set IShLinkA = Nothing
    Else
      If IParentISF.GetDisplayNameOf(pIDLToParent, SHGDNConstants.SHGDN_FORPARSING, dispName) = S_OK Then
        path = STRRETToString(dispName, pIDLToParent)
        hReparsePoint = CreateFileAsLong(StrPtr(path), 0, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS Or FILE_FLAG_OPEN_REPARSE_POINT, 0)
        If hReparsePoint <> INVALID_HANDLE_VALUE Then
          If DeviceIoControl(hReparsePoint, FSCTL_GET_REPARSE_POINT, 0, 0, VarPtr(bBuffer(0)), MAXIMUM_REPARSE_DATA_BUFFER_SIZE, bytesReturned, 0) Then
            CopyMemory VarPtr(reparseDetails), VarPtr(bBuffer(0)), LenB(reparseDetails)
            ret = String$(reparseDetails.SubstituteNameLength + 1, 0)
            lstrcpyn StrPtr(ret), VarPtr(bBuffer(16)) + reparseDetails.SubstituteNameOffset, reparseDetails.SubstituteNameLength + 1
            If bBuffer(16) = Asc("\") Then
              ' starts with "\??\"
              GetLinkTarget = Mid$(ret, 5, lstrlen(StrPtr(ret)) - 4)
            Else
              GetLinkTarget = Left$(ret, lstrlen(StrPtr(ret)))
            End If
          End If

          CloseHandle hReparsePoint
        End If
      End If
    End If
  End If
End Function

Private Function GetOverlayIndex(IParentISF As IVBShellFolder, pIDLToParent As Long) As Long
  Dim IParentISIO As IVBShellIconOverlay
  Dim itemAttributes As SFGAOConstants
  Dim overlayIndex As Long

  IParentISF.QueryInterface IID_IShellIconOverlay, IParentISIO
  If IParentISIO Is Nothing Then
    itemAttributes = SFGAOConstants.SFGAO_SHARE Or SFGAOConstants.SFGAO_LINK
    IParentISF.GetAttributesOf 1, pIDLToParent, itemAttributes
    If itemAttributes And SFGAOConstants.SFGAO_SHARE Then
      overlayIndex = 1
    End If
    If itemAttributes And SFGAOConstants.SFGAO_LINK Then
      overlayIndex = 2
    End If
  Else
    If IParentISIO.GetOverlayIndex(pIDLToParent, overlayIndex) <> S_OK Then
      overlayIndex = 0
    End If
    Set IParentISIO = Nothing
  End If

  GetOverlayIndex = overlayIndex
End Function

Private Function GetSysIconIndex(ByVal pIDLToDesktop As Long) As Long
  Const SHGFI_PIDL = &H8
  Const SHGFI_SMALLICON = &H1
  Const SHGFI_SYSICONINDEX = &H4000
  Dim fileInfo As SHFILEINFO
  Dim flags As Long

  flags = SHGFI_PIDL Or SHGFI_SYSICONINDEX Or SHGFI_SMALLICON
  SHGetFileInfo pIDLToDesktop, 0, fileInfo, LenB(fileInfo), flags
  GetSysIconIndex = fileInfo.iIcon
End Function

Private Function HiWord(ByVal v As Long) As Integer
  Dim ret As Integer

  CopyMemory VarPtr(ret), VarPtr(v) + LenB(ret), LenB(ret)
  HiWord = ret
End Function

Private Sub InsertOpenThisFolderMenuItem(ByVal hMenu As Long, ByVal pMenuItemData As Long)
  Const MFS_ENABLED = &H0
  Const MFT_OWNERDRAW = &H100
  Const MFT_SEPARATOR = &H800
  Const MIIM_DATA = &H20
  Const MIIM_FTYPE = &H100
  Const MIIM_ID = &H2
  Const MIIM_STATE = &H1
  Dim menuItem As MENUITEMINFO
  Dim miData As MENUITEMDATA
  Dim pMIData As Long

  menuItem.cbSize = LenB(menuItem)
  menuItem.fMask = MIIM_ID Or MIIM_FTYPE Or MIIM_STATE Or MIIM_DATA
  menuItem.fType = MFT_OWNERDRAW
  menuItem.fState = MFS_ENABLED
  menuItem.wID = nextCommandID
  On Error Resume Next
  nextCommandID = nextCommandID + 1
  If Err Then
    MsgBox "Too many menu items!"
  End If
  On Error GoTo 0

  CopyMemory VarPtr(miData), pMenuItemData, LenB(miData)
  miData.itemType = MenuItemTypeConstants.mitOpenThisFolderItem
  miData.hasSubMenu = False
  miData.IParentISF.AddRef
  miData.pIDLToDesktop = ILClone(miData.pIDLToDesktop)
  miData.pIDLToParent = ILClone(miData.pIDLToParent)

  pMIData = HeapAlloc(GetProcessHeap, 0, LenB(miData))
  CopyMemory pMIData, VarPtr(miData), miData.cbSize
  menuItem.dwItemData = pMIData
  ZeroMemory VarPtr(miData), LenB(miData)

  InsertMenuItem hMenu, 0, 1, menuItem

  menuItem.fMask = MIIM_FTYPE Or MIIM_DATA
  menuItem.fType = MFT_SEPARATOR
  If themedMenus Then
    menuItem.fType = menuItem.fType Or MFT_OWNERDRAW
  End If

  miData.cbSize = LenB(miData)
  miData.itemType = MenuItemTypeConstants.mitSeparator

  pMIData = HeapAlloc(GetProcessHeap, 0, LenB(miData))
  CopyMemory pMIData, VarPtr(miData), miData.cbSize
  menuItem.dwItemData = pMIData

  InsertMenuItem hMenu, 1, 1, menuItem
End Sub

Private Function IsLower(IParentISF As IVBShellFolder, firstPIDL As Long, secondPIDL As Long) As Boolean
  IsLower = (IParentISF.CompareIDs(sortColumn, firstPIDL, secondPIDL) < 0)
End Function

Private Function IsSeparator(ByVal hMenu As Long, ByVal itemID As Long, Optional ByVal isPosition As Boolean = False) As Boolean
  Const MFT_SEPARATOR = &H800
  Const MIIM_FTYPE = &H100
  Dim menuItem As MENUITEMINFO

  If IsMenu(hMenu) Then
    menuItem.cbSize = LenB(menuItem)
    menuItem.fMask = MIIM_FTYPE
    GetMenuItemInfo hMenu, itemID, Abs(isPosition), menuItem
    IsSeparator = (menuItem.fType And MFT_SEPARATOR)
  End If
End Function

Private Sub LayoutMenuItem(hTheme As Long, itemType As MenuItemTypeConstants, itemRectangle As RECT, itemText As String, itemMetrics As DRAWITEMMETRICS)
  Const MENU_POPUPBACKGROUND = 9
  Const MENU_POPUPCHECK = 11
  Const MENU_POPUPCHECKBACKGROUND = 12
  Const MENU_POPUPITEM = 14
  Const TMT_BORDERSIZE = 2403
  Const TMT_CONTENTMARGINS = 3602
  Dim cx As Long
  Dim cy As Long
  Dim drawingSize As Size
  Dim iconAreaSize As Size
  Dim itemHeight As Long
  Dim measureRectangle As RECT
  Dim measureSize As Size
  Dim popupBgBorderSize As Long
  Dim popupBorderSize As Long
  Dim popupCheckBgMargins As MARGINS
  Dim popupCheckMargins As MARGINS
  Dim popupItemMargins As MARGINS
  Dim popupTextMargins As MARGINS
  Dim separatorSize As Size
  Dim textSize As Size
  Dim x As Long
  Dim y As Long

  If hTheme Then
    itemHeight = (itemRectangle.Bottom - itemRectangle.Top)

    GetThemeInt hTheme, MENU_POPUPITEM, 0, TMT_BORDERSIZE, popupBorderSize
    GetThemeInt hTheme, MENU_POPUPBACKGROUND, 0, TMT_BORDERSIZE, popupBgBorderSize
    GetThemeMargins hTheme, 0, MENU_POPUPCHECKBACKGROUND, 0, TMT_CONTENTMARGINS, 0, popupCheckBgMargins
    GetThemeMargins hTheme, 0, MENU_POPUPCHECK, 0, TMT_CONTENTMARGINS, 0, popupCheckMargins
    GetThemeMargins hTheme, 0, MENU_POPUPITEM, 0, TMT_CONTENTMARGINS, 0, popupItemMargins
    popupTextMargins = popupItemMargins
    popupTextMargins.cxRightWidth = popupBorderSize
    popupTextMargins.cxLeftWidth = popupBgBorderSize

    MeasureItemParts hTheme, itemType, itemText, iconAreaSize, textSize, separatorSize

    x = itemRectangle.Left + popupItemMargins.cxLeftWidth
    y = itemRectangle.Top

    If iconAreaSize.cx Then
      x = x + popupCheckBgMargins.cxLeftWidth
      cx = iconAreaSize.cx
      cy = iconAreaSize.cy - (popupCheckBgMargins.cyTopHeight + popupCheckBgMargins.cyBottomHeight)
      SetRect measureRectangle, x, y, x + cx, y + cy
      SetRect itemMetrics.rcIcon, measureRectangle.Left + popupCheckMargins.cxLeftWidth, measureRectangle.Top + popupCheckMargins.cyTopHeight, measureRectangle.Right - popupCheckMargins.cxRightWidth, measureRectangle.Bottom - popupCheckMargins.cyBottomHeight
      OffsetRect itemMetrics.rcIcon, 0, (itemHeight - cy) / 2
      x = x + popupCheckBgMargins.cxRightWidth
      x = x + cx
    End If
    If textSize.cx Then
      cx = textSize.cx
      cy = textSize.cy
      SetRect measureRectangle, x, y, x + cx, y + cy
      SetRect itemMetrics.rcText, measureRectangle.Left + popupTextMargins.cxLeftWidth, measureRectangle.Top + popupTextMargins.cyTopHeight, measureRectangle.Right - popupTextMargins.cxRightWidth, measureRectangle.Bottom - popupTextMargins.cyBottomHeight
      OffsetRect itemMetrics.rcText, 0, (itemHeight - cy) / 2
      x = x + cx
    End If

    drawingSize.cx = iconAreaSize.cx
    drawingSize.cy = iconAreaSize.cy - (popupCheckBgMargins.cyTopHeight + popupCheckBgMargins.cyBottomHeight)

    measureSize.cx = drawingSize.cx + popupCheckBgMargins.cxLeftWidth + popupCheckBgMargins.cxRightWidth
    measureSize.cy = drawingSize.cy + popupCheckBgMargins.cyTopHeight + popupCheckBgMargins.cyBottomHeight

    x = itemRectangle.Left

    drawingSize.cx = iconAreaSize.cx
    measureSize.cx = drawingSize.cx + popupCheckBgMargins.cxLeftWidth + popupCheckBgMargins.cxRightWidth
    measureSize.cy = drawingSize.cy + popupCheckBgMargins.cyTopHeight + popupCheckBgMargins.cyBottomHeight

    SetRect itemMetrics.rcGutter, x, y, x + popupItemMargins.cxLeftWidth + measureSize.cx, y + itemHeight

    If itemType = MenuItemTypeConstants.mitSeparator Then
      x = itemMetrics.rcGutter.Right + popupItemMargins.cxLeftWidth

      SetRect measureRectangle, x, y, itemRectangle.Right - popupItemMargins.cxRightWidth, y + separatorSize.cy
      SetRect itemMetrics.rcSeparator, measureRectangle.Left + popupItemMargins.cxLeftWidth, measureRectangle.Top + popupItemMargins.cyTopHeight, measureRectangle.Right - popupItemMargins.cxRightWidth, measureRectangle.Bottom - popupItemMargins.cyBottomHeight
      OffsetRect itemMetrics.rcSeparator, 0, (itemHeight - separatorSize.cy) / 2
    Else
      x = itemRectangle.Left + popupItemMargins.cxLeftWidth

      SetRect itemMetrics.rcSelection, x, y, itemRectangle.Right - popupItemMargins.cxRightWidth, y + itemHeight
    End If
  End If
End Sub

Private Function LoWord(ByVal v As Long) As Integer
  Dim ret As Integer

  CopyMemory VarPtr(ret), VarPtr(v), LenB(ret)
  LoWord = ret
End Function

Private Function MakeDWord(ByVal Lo As Integer, ByVal Hi As Integer) As Long
  Dim ret As Long

  CopyMemory ByVal VarPtr(ret), ByVal VarPtr(Lo), LenB(Lo)
  CopyMemory ByVal VarPtr(ret) + LenB(Lo), ByVal VarPtr(Hi), LenB(Hi)

  MakeDWord = ret
End Function

Private Sub MeasureItem(itemText As String, itemType As MenuItemTypeConstants, cx As Long, cy As Long)
  Const DT_CALCRECT = &H400
  Const DT_LEFT = &H0
  Const DT_NOPREFIX = &H800
  Const DT_SINGLELINE = &H20
  Const MENU_POPUPCHECKBACKGROUND = 12
  Const MENU_POPUPITEM = 14
  Const TMT_CONTENTMARGINS = 3602
  Const WM_GETFONT = &H31
  Dim iconAreaSize As Size
  Dim hDC As Long
  Dim hDCCompatible As Long
  Dim hDCToUse As Long
  Dim hOldFont As Long
  Dim hTheme As Long
  Dim popupCheckBgMargins As MARGINS
  Dim popupItemMargins As MARGINS
  Dim separatorSize As Size
  Dim textRectangle As RECT
  Dim textSize As Size

  If themeableOS Then
    hTheme = OpenThemeData(Me.hWnd, StrPtr("MENU"))
    If hTheme Then
      GetThemeMargins hTheme, 0, MENU_POPUPCHECKBACKGROUND, 0, TMT_CONTENTMARGINS, 0, popupCheckBgMargins
      GetThemeMargins hTheme, 0, MENU_POPUPITEM, 0, TMT_CONTENTMARGINS, 0, popupItemMargins

      MeasureItemParts hTheme, itemType, itemText, iconAreaSize, textSize, separatorSize
      cx = iconAreaSize.cx + popupCheckBgMargins.cxLeftWidth + popupCheckBgMargins.cxRightWidth
      If itemText <> "" Then
        cx = cx + textSize.cx
      End If
      cx = cx + popupItemMargins.cxLeftWidth + popupItemMargins.cxRightWidth
      If itemType = MenuItemTypeConstants.mitSeparator Then
        cy = separatorSize.cy
      Else
        cy = IIf(iconAreaSize.cy > textSize.cy, iconAreaSize.cy, textSize.cy)
      End If

      CloseThemeData hTheme
      Exit Sub
    End If
  End If

  If hMenuFont Then
    hDCCompatible = GetDC(0)
    If hDCCompatible Then
      hDC = CreateCompatibleDC(hDCCompatible)
      hDCToUse = hDC
    End If
  End If
  If hDCToUse Then
    hOldFont = SelectObject(hDCToUse, hMenuFont)
  Else
    hDCToUse = Me.hDC
    hOldFont = SelectObject(hDCToUse, SendMessage(Me.hWnd, WM_GETFONT, 0, 0))
  End If

  If itemText <> "" Then
    DrawText hDCToUse, StrPtr(itemText), Len(itemText), textRectangle, DT_CALCRECT Or DT_NOPREFIX Or DT_LEFT Or DT_SINGLELINE
    cx = textRectangle.Right - textRectangle.Left + 2 * HMARGIN_TEXT
    cy = textRectangle.Bottom - textRectangle.Top + 2 * VMARGIN_TEXT
  End If
  cx = cx + iconSize.cx + 2 * HMARGIN_ICON
  If cy < iconSize.cy + VMARGIN_ICON Then
    cy = iconSize.cy + VMARGIN_ICON
  End If

  If hOldFont Then
    SelectObject hDCToUse, hOldFont
  End If
  If hDC Then
    DeleteDC hDC
  End If
  If hDCCompatible Then
    ReleaseDC 0, hDCCompatible
  End If
End Sub

Private Sub MeasureItemParts(hTheme As Long, itemType As MenuItemTypeConstants, itemText As String, iconAreaSize As Size, textSize As Size, separatorSize As Size)
  Const DT_LEFT = &H0
  Const DT_NOPREFIX = &H800
  Const DT_SINGLELINE = &H20
  Const MENU_POPUPBACKGROUND = 9
  Const MENU_POPUPCHECK = 11
  Const MENU_POPUPCHECKBACKGROUND = 12
  Const MENU_POPUPITEM = 14
  Const MENU_POPUPSEPARATOR = 15
  Const TMT_BORDERSIZE = 2403
  Const TMT_CONTENTMARGINS = 3602
  Const TS_TRUE = 1
  Dim drawingSize As Size
  Dim hDC As Long
  Dim hDCCompatible As Long
  Dim popupBgBorderSize As Long
  Dim popupBorderSize As Long
  Dim popupCheckBgMargins As MARGINS
  Dim popupCheckMargins As MARGINS
  Dim popupItemMargins As MARGINS
  Dim popupSeparatorSize As Size
  Dim popupTextMargins As MARGINS
  Dim textRectangle As RECT

  If hTheme Then
    hDCCompatible = GetDC(0)
    If hDCCompatible Then
      hDC = CreateCompatibleDC(hDCCompatible)
      If hDC Then
        GetThemePartSize hTheme, 0, MENU_POPUPSEPARATOR, 0, 0, TS_TRUE, popupSeparatorSize
        GetThemeInt hTheme, MENU_POPUPITEM, 0, TMT_BORDERSIZE, popupBorderSize
        GetThemeInt hTheme, MENU_POPUPBACKGROUND, 0, TMT_BORDERSIZE, popupBgBorderSize
        GetThemeMargins hTheme, 0, MENU_POPUPCHECK, 0, TMT_CONTENTMARGINS, 0, popupCheckMargins
        GetThemeMargins hTheme, 0, MENU_POPUPCHECKBACKGROUND, 0, TMT_CONTENTMARGINS, 0, popupCheckBgMargins
        GetThemeMargins hTheme, 0, MENU_POPUPITEM, 0, TMT_CONTENTMARGINS, 0, popupItemMargins

        popupTextMargins = popupItemMargins
        popupTextMargins.cxRightWidth = popupBorderSize
        popupTextMargins.cxLeftWidth = popupBgBorderSize

        drawingSize = iconSize
        drawingSize.cy = drawingSize.cy + popupCheckBgMargins.cyTopHeight + popupCheckBgMargins.cyBottomHeight
        iconAreaSize.cx = drawingSize.cx + popupCheckMargins.cxLeftWidth + popupCheckMargins.cxRightWidth
        iconAreaSize.cy = drawingSize.cy + popupCheckMargins.cyTopHeight + popupCheckMargins.cyBottomHeight

        If itemType = MenuItemTypeConstants.mitSeparator Then
          drawingSize = iconSize
          drawingSize.cy = popupSeparatorSize.cy
          separatorSize.cx = drawingSize.cx + popupItemMargins.cxLeftWidth + popupItemMargins.cxRightWidth
          separatorSize.cy = drawingSize.cy + popupItemMargins.cyTopHeight + popupItemMargins.cyBottomHeight
        ElseIf itemText <> "" Then
          GetThemeTextExtent hTheme, hDC, MENU_POPUPITEM, 0, StrPtr(itemText), Len(itemText), DT_NOPREFIX Or DT_LEFT Or DT_SINGLELINE, 0, textRectangle
          textSize.cx = textRectangle.Right - textRectangle.Left + popupTextMargins.cxLeftWidth + popupTextMargins.cxRightWidth
          textSize.cy = textRectangle.Bottom - textRectangle.Top + popupTextMargins.cyTopHeight + popupTextMargins.cyBottomHeight
        End If

        DeleteDC hDC
      End If
      ReleaseDC 0, hDCCompatible
    End If
  End If
End Sub

Private Sub QuickSort(IParentISF As IVBShellFolder, arrayToSort() As Long, ByVal lowerIndex As Long, ByVal upperIndex As Long)
  Dim i As Long
  Dim j As Long
  Dim pivot As Long
  Dim tmp As Long

  i = lowerIndex
  j = upperIndex
  pivot = arrayToSort((lowerIndex + upperIndex) / 2)

  Do
    While IsLower(IParentISF, arrayToSort(i), pivot)
      i = i + 1
    Wend
    While IsLower(IParentISF, pivot, arrayToSort(j))
      j = j - 1
    Wend

    If i <= j Then
      tmp = arrayToSort(i)
      arrayToSort(i) = arrayToSort(j)
      arrayToSort(j) = tmp
      i = i + 1
      j = j - 1
    End If
  Loop Until i > j

  If (lowerIndex < j) Then
    QuickSort IParentISF, arrayToSort, lowerIndex, j
  End If
  If (i < upperIndex) Then
    QuickSort IParentISF, arrayToSort, i, upperIndex
  End If
End Sub

Private Sub RemoveDoubleSeparators(ByVal hMenu As Long)
  Const MF_BYPOSITION = &H400
  Dim i As Integer
  Dim iLastSep As Integer

  iLastSep = -2
  If IsMenu(hMenu) Then
    While IsSeparator(hMenu, 0, True)
      RemoveMenu hMenu, 0, MF_BYPOSITION
    Wend

    While i < GetMenuItemCount(hMenu)
      If IsSeparator(hMenu, i, True) Then
        If i = iLastSep + 1 Then
          ' we've found two consecutive separators
          RemoveMenu hMenu, i, MF_BYPOSITION
        Else
          iLastSep = i
          i = i + 1
        End If
      Else
        i = i + 1
      End If
    Wend

    i = i - 1
    While IsSeparator(hMenu, i, True)
      RemoveMenu hMenu, i, MF_BYPOSITION
      i = i - 1
    Wend
  End If
End Sub

Private Sub SplitFullyQualifiedPIDL(pIDLToDesktop As Long, IParent As IVBShellFolder, pIDLToParent As Long)
  If ILGetSize(pIDLToDesktop) = 2 Then
    Set IParent = IDesktop
    pIDLToParent = pIDLToDesktop
  Else
    SHBindToParent pIDLToDesktop, IID_IShellFolder, IParent, VarPtr(pIDLToParent)
  End If
End Sub

Private Function STRRETToString(Data As STRRET, ByVal pIDL As Long) As String
  Dim ret As String

  ret = String$(MAX_PATH, Chr$(0))
  StrRetToBuf Data, pIDL, StrPtr(ret), MAX_PATH
  STRRETToString = Left$(ret, lstrlen(StrPtr(ret)))
End Function

' subclasses this Form
Private Sub Subclass()
  UnSubclass
  StartListening Me, Me.hWnd
End Sub

' unsubclasses this Form
Private Sub UnSubclass()
  StopListening Me, Me.hWnd
End Sub
